#!/usr/bin/perl
#
# cheesey package creation helper
# pass it files or folders
# for files, it simply prints on stdout
# for folders, prints files in the folder IFF they are under source control!
#
# ADOBE SYSTEMS INCORPORATED
# Copyright 2008 Adobe Systems Incorporated. All Rights Reserved.
#
# NOTICE:  Adobe permits you to use, modify, and distribute this file in
# accordance with the terms of the Adobe license agreement accompanying it.
# If you have received this file from a source other than Adobe, then your use,
# modification, or distribution of it requires the prior written permission of Adobe.
#

open(CLIENT, "p4 client -o|");

while(<CLIENT>)
{
  if(/\s*#/)
    { goto NEXT }
  if(/Root:\s+(\S+)/)
    { $root = $1 }
  if(/Client:\s+(\S+)/)
    { $client= $1 }
  elsif(/View:/)
    { goto VIEW }
NEXT:
}
VIEW:
$root =~ s/\\/\//g;
$droot = $root;
chomp($root = `cygpath -a -u $root`);
$root =~ s/[\\\/]$//;
while(<CLIENT>)
{
  if(/(\/\/\S+)\/\.\.\.\s+(\/\/\S+)\/\.\.\./)
  { 
    $dpath = $1;
    $lpath = $2;
    $lpath =~ s/\/\/$client/$root/;
    push(@dpaths, $dpath);
    push(@lpaths, $lpath);
  }
}
close(CLIENT);
open(FILES, "p4 files $droot/...|");
$pi = 0;
$max = $#dpaths+1;
while(<FILES>)
{
  if(/\s*(\/\/.*)#\d+\s+-\s+(?!delete)/)
  {
    $file = $1;
    $spi = $pi;
    while(index(lc($file), lc($dpaths[$pi])) != 0)
    {
      $pi = ($pi + 1) % $max;
      if($pi == $spi)
      {
        print STDERR "Couldn't map: $file\n";
        goto BADFILE;
      }
    }
    substr($file, 0, length($dpaths[$pi])) = $lpaths[$pi];
    push(@dfiles, $file);
#print STDERR "% $file\n";
  }
BADFILE:
}
chomp($pwd = `cygpath -a -u .`);
$offs = length($pwd);
for $tpath (@ARGV)
{
#print STDERR "- $tpath\n";
  if(-d $tpath)
  {
    $found = 0;
    chomp($apath = `cygpath -a -u $tpath`);
    $apath = $apath . "/";
#print STDERR "+ $apath\n";
    for $mf (@dfiles)
    {
#print STDERR "= $mf\n";
      if(index(lc($mf), lc($apath)) == 0)
      {
        print substr($mf, $offs) . "\n";
        $found++;
      }
    }
    if($found == 0)
    {
      print STDERR "Warning: $tpath matched nothing; passing on whole dir\n";
      print "$tpath\n";
    }
  }
  else
    { print "$tpath\n" }
}
